;Author: Thomas Antony
;Date : 16th April 2004
;Compiled using: GoASM
;Linker: GoLink
;Thanx to: Programming in Windows by Charles Petzold for the idea. This program is 
;in fuction to one of the programs given in the book. But I only took the idea from
;it and nothing else
#include \GoASM\includeA\windows.inc
#include \GoASM\includeA\all_api.inc
#include \GoASM\includeA\comdef.inc
CONST SECTION
CommandId	equ	1001
RetnId	equ	1002
ErrorId	equ	1003
SendId	equ	1004

DATA SECTION
ClassName	db	'TomsWindowClass',0
StaticClass	db	'static',0
DescText	db	'	This is a utility for testing the various MCI commands. Type in'
		db	'an MCI command and click Send to see the result. For eg. type'
		db	'"set cdaudio door open" to open the CD drive. Try out the other MCI commands.',13,10,13,10
		db	'HaveFun!!',13,10
		db	'Thomas Antony',13,10
		db	'webmaster@thomasantony.cjb.net',0
CmdBuffer	db	256 dup ?
ErrBuffer	db	256 dup ?
RetnBuffer	db	256 dup ?

hInstance	dd	?
hError	dd	?
hSend		dd	?
hRetn		dd	?
hCmd		dd	?

wc	WNDCLASSEX
ps	PAINTSTRUCT
msg	MSG
CODE SECTION
start:
	invoke GetModuleHandle,NULL
	mov [hInstance],eax
	invoke WinMain,[hInstance],0,0,SW_SHOW
	ret
WinMain FRAME hInst,hPrevInst,CmdLine,CmdShow
LOCAL hwnd

	mov D[wc.cbSize],SIZEOF wc
	mov D[wc.style],CS_VREDRAW+CS_HREDRAW
	mov D[wc.lpfnWndProc],OFFSET WndProc
	mov D[wc.cbClsExtra],0
	mov D[wc.cbWndExtra],0
	push [hInst]
	pop [wc.hInstance]
	invoke LoadIcon,0,IDI_APPLICATION
	mov D[wc.hIcon],eax
	mov D[wc.hIconSm],eax
	invoke LoadCursor,0,IDC_ARROW
	mov D[wc.hCursor],eax
	mov D[wc.hbrBackground],COLOR_BACKGROUND+10
	mov D[wc.lpszMenuName],0
	mov D[wc.lpszClassName],OFFSET ClassName
	invoke RegisterClassEx,ADDR wc
	invoke CreateWindowEx,0,OFFSET ClassName,'MCITest by Thomas Antony',WS_OVERLAPPEDWINDOW,150,100,500,280,0,0,[hInst],0
	mov [hwnd],eax
	invoke ShowWindow,[hwnd],[CmdShow]
	invoke UpdateWindow,[hwnd]
msg_loop:
	invoke GetMessage,ADDR msg,0,0,0
	or eax,eax
	jz > end_loop
	invoke TranslateMessage,ADDR msg
	invoke DispatchMessage,ADDR msg
	jmp msg_loop
end_loop:
mov eax,[msg.wParam]
ret
WinMain ENDF
WndProc FRAME hWnd,uMsg,wParam,lParam
LOCAL hdc
mov eax,[uMsg]
cmp eax,WM_COMMAND
je > wm_command
cmp eax,WM_DESTROY
je > wm_destroy
cmp eax,WM_CREATE
je > wm_create
jmp > defproc
wm_create:
	invoke CreateWindowEx,0,OFFSET StaticClass,'MCI Command:',WS_CHILD+WS_VISIBLE,10,15,100,20,[hWnd],0,[hInstance],0
	invoke CreateWindowEx,0,OFFSET StaticClass,'Return String:',WS_CHILD+WS_VISIBLE,10,40,100,20,[hWnd],0,[hInstance],0
	invoke CreateWindowEx,0,OFFSET StaticClass,'Error Code :',WS_CHILD+WS_VISIBLE,10,65,100,20,[hWnd],0,[hInstance],0
	invoke CreateWindowEx,0,OFFSET StaticClass,OFFSET DescText,WS_CHILD+WS_VISIBLE,10,115,480,140,[hWnd],0,[hInstance],0

	invoke CreateWindowEx,0,'button','Send',WS_CHILD+WS_VISIBLE+BS_DEFPUSHBUTTON,360,10,100,25,[hWnd],SendId,[hInstance],0
	mov [hSend],eax
	invoke CreateWindowEx,0,OFFSET StaticClass,0,WS_CHILD+WS_VISIBLE,110,65,400,50,[hWnd],ErrorId,[hInstance],0
	mov [hError],eax
	invoke CreateWindowEx,0,OFFSET StaticClass,0,WS_CHILD+WS_VISIBLE,110,40,150,20,[hWnd],RetnId,[hInstance],0
	mov [hRetn],eax
	invoke CreateWindowEx,WS_EX_CLIENTEDGE,'edit',0,WS_CHILD+WS_VISIBLE+ES_AUTOHSCROLL,110,10,250,25,[hWnd],CommandId,[hInstance],0
	mov [hCmd],eax
	invoke SetFocus,eax
	jmp > allright
wm_command:
	mov eax,[wParam]
	cmp eax,SendId
	jne > allright
	invoke GetWindowText,[hCmd],OFFSET CmdBuffer,256
	invoke mciSendString,OFFSET CmdBuffer,OFFSET RetnBuffer,256,[hWnd]
	push eax
	lea edi,RetnBuffer
	mov al,B[edi]
	cmp al,"1"
	je >
	invoke SetWindowText,[hRetn],OFFSET RetnBuffer
	jmp > go
:
	invoke SetWindowText,[hRetn],'TRUE'
go:
	pop eax
	invoke mciGetErrorString,eax,OFFSET ErrBuffer,256
	invoke SetWindowText,[hError],OFFSET ErrBuffer
	invoke SetFocus,[hCmd]
	jmp > allright
wm_destroy:
	invoke PostQuitMessage,NULL
	jmp > allright
defproc:
	invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]
	ret

allright:
xor eax,eax
ret
WndProc ENDF
